/**
 * 
 */
package org.gcube.portlets.user.dataminermanager.client.form;

import org.gcube.portlets.user.dataminermanager.client.bean.parameters.ObjectParameter;
import org.gcube.portlets.user.dataminermanager.client.bean.parameters.Parameter;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.widget.core.client.form.TextField;

/**
 * 
 * @author Giancarlo Panichi
 * email: <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public class StringFld extends AbstractFld {

	private TextField textField;

	/**
	 * @param parameter
	 */
	public StringFld(Parameter parameter) {
		super(parameter);

		textField = new TextField();
		ObjectParameter p = (ObjectParameter) parameter;
		textField.setValue(p.getDefaultValue());

		if (p.getDefaultValue() == null)
			textField.setAllowBlank(false);
		if (p.getDescription() != null)
			textField.setToolTip(p.getDescription());

	}

	/**
	 * 
	 */
	@Override
	public String getValue() {
		return textField.getValue();
	}

	/**
	 * 
	 */
	@Override
	public Widget getWidget() {
		return textField;
	}

}
