/**
 * 
 */
package org.gcube.portlets.user.dataminermanager.client.form;

import org.gcube.portlets.user.dataminermanager.client.bean.parameters.ObjectParameter;
import org.gcube.portlets.user.dataminermanager.client.bean.parameters.Parameter;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.widget.core.client.form.CheckBox;

/**
 * @author ceras
 *
 */
public class BooleanFld extends AbstractFld {

	private CheckBox checkBox = new CheckBox();

	/**
	 * @param parameter
	 */
	public BooleanFld(Parameter parameter) {
		super(parameter);

		ObjectParameter p = (ObjectParameter)parameter;
		checkBox.setValue(!p.getDefaultValue().toUpperCase().equals("FALSE"));
		if (p.getDescription()!=null)
			checkBox.setTitle(p.getDescription());
		checkBox.setBoxLabel(p.getName());
	}

	
	@Override
	public String getValue() {
		return (checkBox.getValue() ? "true" : "false");
	}

	@Override
	public Widget getWidget() {
		return checkBox;
	}

}
