package org.gcube.portlets.user.dataminermanager.client.form;

import org.gcube.portlets.user.dataminermanager.client.bean.parameters.ObjectParameter;
import org.gcube.portlets.user.dataminermanager.client.bean.parameters.Parameter;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.widget.core.client.form.DoubleField;

/**
 * 
 * @author Giancarlo Panichi email: <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 *
 */
public class DoubleFld extends AbstractFld {

	private DoubleField numberField;

	/**
	 * @param operator
	 */
	public DoubleFld(Parameter parameter) {
		super(parameter);

		ObjectParameter p = (ObjectParameter) parameter;

		numberField = new DoubleField();

		if (p.getDefaultValue() != null)
			numberField.setValue(Double.parseDouble(p.getDefaultValue()));

		if (p.getDescription() != null)
			numberField.setTitle(p.getDescription());

	}

	/**
	 * 
	 */
	@Override
	public String getValue() {
		return numberField.getCurrentValue().toString();
	}

	/**
	 * 
	 */
	@Override
	public Widget getWidget() {
		return numberField;
	}

}
