
package org.gcube.portlets.user.dataminermanager.client.form;

import org.gcube.portlets.user.dataminermanager.client.bean.parameters.ObjectParameter;
import org.gcube.portlets.user.dataminermanager.client.bean.parameters.Parameter;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.widget.core.client.form.IntegerField;


/**
 * 
 * @author Giancarlo Panichi
 * email: <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public class IntFld extends AbstractFld {

	
	private IntegerField numberField;
	
	/**
	 * @param operator
	 */
	public IntFld(Parameter parameter) {
		super(parameter);

		ObjectParameter p = (ObjectParameter) parameter;

		
		numberField = new IntegerField();

		if (p.getDefaultValue() != null)
			numberField.setValue(Integer.parseInt(p.getDefaultValue()));

		if (p.getDescription() != null)
			numberField.setTitle(p.getDescription());
		numberField.setAllowBlank(false);		
	
	}

	/**
	 * 
	 */
	@Override
	public String getValue() {
		Integer i = numberField.getCurrentValue();
		return i.toString();
	}

	/**
	 * 
	 */
	@Override
	public Widget getWidget() {
		return numberField;
	}

}
