package org.gcube.portlets.user.dataminermanager.shared.workspace;

import java.io.Serializable;

/**
 * 
 * @author Giancarlo Panichi email: <a
 *         href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a>
 *
 */
public class ImportedData implements Serializable {
	private static final long serialVersionUID = -4408116083736005844L;

	private ItemDescription folder;

	public ImportedData() {
		super();
	}

	public ImportedData(ItemDescription folder) {
		super();
		this.folder = folder;
	}

	public ItemDescription getFolder() {
		return folder;
	}

	public void setFolder(ItemDescription folder) {
		this.folder = folder;
	}

	@Override
	public String toString() {
		return "ImportedData [folder=" + folder + "]";
	}

}
